/* Application.c generated by valac 0.56.1, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * Copyright (c) 2022 Andrew Vojak (https://avojak.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Andrew Vojak <andrew.vojak@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <granite.h>
#include <sys/utsname.h>

#define CONSTANTS_APP_ID "com.github.avojak.warble"
#define CONSTANTS_VERSION "1.4.0"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WARBLE_TYPE_APPLICATION (warble_application_get_type ())
#define WARBLE_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_TYPE_APPLICATION, WarbleApplication))
#define WARBLE_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_TYPE_APPLICATION, WarbleApplicationClass))
#define WARBLE_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_TYPE_APPLICATION))
#define WARBLE_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_TYPE_APPLICATION))
#define WARBLE_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_TYPE_APPLICATION, WarbleApplicationClass))

typedef struct _WarbleApplication WarbleApplication;
typedef struct _WarbleApplicationClass WarbleApplicationClass;
typedef struct _WarbleApplicationPrivate WarbleApplicationPrivate;

#define WARBLE_TYPE_MAIN_WINDOW (warble_main_window_get_type ())
#define WARBLE_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_TYPE_MAIN_WINDOW, WarbleMainWindow))
#define WARBLE_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_TYPE_MAIN_WINDOW, WarbleMainWindowClass))
#define WARBLE_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_TYPE_MAIN_WINDOW))
#define WARBLE_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_TYPE_MAIN_WINDOW))
#define WARBLE_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_TYPE_MAIN_WINDOW, WarbleMainWindowClass))

typedef struct _WarbleMainWindow WarbleMainWindow;
typedef struct _WarbleMainWindowClass WarbleMainWindowClass;
enum  {
	WARBLE_APPLICATION_0_PROPERTY,
	WARBLE_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* warble_application_properties[WARBLE_APPLICATION_NUM_PROPERTIES];

#define WARBLE_MODELS_TYPE_DICTIONARY (warble_models_dictionary_get_type ())
#define WARBLE_MODELS_DICTIONARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionary))
#define WARBLE_MODELS_DICTIONARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionaryClass))
#define WARBLE_MODELS_IS_DICTIONARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_MODELS_TYPE_DICTIONARY))
#define WARBLE_MODELS_IS_DICTIONARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_MODELS_TYPE_DICTIONARY))
#define WARBLE_MODELS_DICTIONARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionaryClass))

typedef struct _WarbleModelsDictionary WarbleModelsDictionary;
typedef struct _WarbleModelsDictionaryClass WarbleModelsDictionaryClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WarbleApplication {
	GtkApplication parent_instance;
	WarbleApplicationPrivate * priv;
};

struct _WarbleApplicationClass {
	GtkApplicationClass parent_class;
};

struct _WarbleApplicationPrivate {
	WarbleMainWindow* main_window;
};

struct _Block1Data {
	int _ref_count_;
	WarbleApplication* self;
	GraniteSettings* granite_settings;
	GtkSettings* gtk_settings;
};

static gint WarbleApplication_private_offset;
static gpointer warble_application_parent_class = NULL;
VALA_EXTERN GSettings* warble_application_settings;
GSettings* warble_application_settings = NULL;
VALA_EXTERN WarbleModelsDictionary* warble_application_dictionary;
WarbleModelsDictionary* warble_application_dictionary = NULL;

VALA_EXTERN GType warble_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleApplication, g_object_unref)
VALA_EXTERN GType warble_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleMainWindow, g_object_unref)
VALA_EXTERN GType warble_models_dictionary_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleModelsDictionary, g_object_unref)
VALA_EXTERN WarbleApplication* warble_application_new (void);
VALA_EXTERN WarbleApplication* warble_application_construct (GType object_type);
static void warble_application_add_new_window (WarbleApplication* self);
VALA_EXTERN WarbleMainWindow* warble_main_window_new (WarbleApplication* application);
VALA_EXTERN WarbleMainWindow* warble_main_window_construct (GType object_type,
                                                WarbleApplication* application);
static void ___lambda50_ (WarbleApplication* self);
static void ____lambda50__gtk_widget_destroy (GtkWidget* _sender,
                                       gpointer self);
static void warble_application_real_activate (GApplication* base);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void warble_application_force_elementary_style (WarbleApplication* self);
static void __lambda51_ (Block1Data* _data1_);
static void ___lambda51__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gint warble_application_main (gchar** args,
                              gint args_length1);
static GObject * warble_application_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
VALA_EXTERN WarbleModelsDictionary* warble_models_dictionary_new (void);
VALA_EXTERN WarbleModelsDictionary* warble_models_dictionary_construct (GType object_type);
static void _warble_application___lambda52_ (WarbleApplication* self,
                                      GApplication* handler);
static void __warble_application___lambda52__g_application_startup (GApplication* _sender,
                                                             gpointer self);
static void warble_application_finalize (GObject * obj);
static GType warble_application_get_type_once (void);

static inline gpointer
warble_application_get_instance_private (WarbleApplication* self)
{
	return G_STRUCT_MEMBER_P (self, WarbleApplication_private_offset);
}

WarbleApplication*
warble_application_construct (GType object_type)
{
	WarbleApplication * self = NULL;
	self = (WarbleApplication*) g_object_new (object_type, "application-id", CONSTANTS_APP_ID, "flags", G_APPLICATION_FLAGS_NONE, NULL);
	return self;
}

WarbleApplication*
warble_application_new (void)
{
	return warble_application_construct (WARBLE_TYPE_APPLICATION);
}

static void
___lambda50_ (WarbleApplication* self)
{
	_g_object_unref0 (self->priv->main_window);
	self->priv->main_window = NULL;
}

static void
____lambda50__gtk_widget_destroy (GtkWidget* _sender,
                                  gpointer self)
{
	___lambda50_ ((WarbleApplication*) self);
}

static void
warble_application_add_new_window (WarbleApplication* self)
{
	WarbleMainWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->main_window;
	if (_tmp0_ == NULL) {
		WarbleMainWindow* _tmp1_;
		WarbleMainWindow* _tmp2_;
		WarbleMainWindow* _tmp3_;
		_tmp1_ = warble_main_window_new (self);
		g_object_ref_sink (_tmp1_);
		_g_object_unref0 (self->priv->main_window);
		self->priv->main_window = _tmp1_;
		_tmp2_ = self->priv->main_window;
		g_signal_connect_object ((GtkWidget*) _tmp2_, "destroy", (GCallback) ____lambda50__gtk_widget_destroy, self, 0);
		_tmp3_ = self->priv->main_window;
		gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp3_);
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		WarbleApplication* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->gtk_settings);
		_g_object_unref0 (_data1_->granite_settings);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda51_ (Block1Data* _data1_)
{
	WarbleApplication* self;
	GraniteSettingsColorScheme _tmp0_;
	GraniteSettingsColorScheme _tmp1_;
	self = _data1_->self;
	_tmp0_ = granite_settings_get_prefers_color_scheme (_data1_->granite_settings);
	_tmp1_ = _tmp0_;
	g_object_set (_data1_->gtk_settings, "gtk-application-prefer-dark-theme", _tmp1_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
}

static void
___lambda51__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda51_ (self);
}

static void
warble_application_real_activate (GApplication* base)
{
	WarbleApplication * self;
	Block1Data* _data1_;
	GraniteSettings* _tmp0_;
	GraniteSettings* _tmp1_;
	GtkSettings* _tmp2_;
	GtkSettings* _tmp3_;
	GraniteSettingsColorScheme _tmp4_;
	GraniteSettingsColorScheme _tmp5_;
	self = (WarbleApplication*) base;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	warble_application_force_elementary_style (self);
	_tmp0_ = granite_settings_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_data1_->granite_settings = _tmp1_;
	_tmp2_ = gtk_settings_get_default ();
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_data1_->gtk_settings = _tmp3_;
	_tmp4_ = granite_settings_get_prefers_color_scheme (_data1_->granite_settings);
	_tmp5_ = _tmp4_;
	g_object_set (_data1_->gtk_settings, "gtk-application-prefer-dark-theme", _tmp5_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
	g_signal_connect_data ((GObject*) _data1_->granite_settings, "notify::prefers-color-scheme", (GCallback) ___lambda51__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	warble_application_add_new_window (self);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

/**
     * Sets the app's icons, cursors, and stylesheet to elementary defaults.
     * See: https://github.com/elementary/granite/pull/501
     */
static void
warble_application_force_elementary_style (WarbleApplication* self)
{
	static const char STYLESHEET_PREFIX[] = "io.elementary.stylesheet";
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	GtkSettings* _tmp2_;
	GtkSettings* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_settings_get_default ();
	gtk_settings = _tmp0_;
	_tmp1_ = gtk_settings;
	g_object_set (_tmp1_, "gtk-cursor-theme-name", "elementary", NULL);
	_tmp2_ = gtk_settings;
	g_object_set (_tmp2_, "gtk-icon-theme-name", "elementary", NULL);
	_tmp3_ = gtk_settings;
	g_object_get (_tmp3_, "gtk-theme-name", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	_tmp7_ = !g_str_has_prefix (_tmp6_, STYLESHEET_PREFIX);
	_g_free0 (_tmp6_);
	if (_tmp7_) {
		GtkSettings* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp8_ = gtk_settings;
		_tmp9_ = g_strjoin (".", STYLESHEET_PREFIX, "blueberry", NULL);
		_tmp10_ = _tmp9_;
		g_object_set (_tmp8_, "gtk-theme-name", _tmp10_, NULL);
		_g_free0 (_tmp10_);
	}
}

static gint
warble_application_main (gchar** args,
                         gint args_length1)
{
	WarbleApplication* app = NULL;
	WarbleApplication* _tmp0_;
	gint result;
	_tmp0_ = warble_application_new ();
	app = _tmp0_;
	result = g_application_run ((GApplication*) app, (gint) args_length1, args);
	_g_object_unref0 (app);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return warble_application_main (argv, argc);
}

static void
_warble_application___lambda52_ (WarbleApplication* self,
                                 GApplication* handler)
{
	g_return_if_fail (handler != NULL);
	hdy_init ();
}

static void
__warble_application___lambda52__g_application_startup (GApplication* _sender,
                                                        gpointer self)
{
	_warble_application___lambda52_ ((WarbleApplication*) self, _sender);
}

static GObject *
warble_application_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WarbleApplication * self;
	GSettings* _tmp0_;
	WarbleModelsDictionary* _tmp1_;
	parent_class = G_OBJECT_CLASS (warble_application_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_TYPE_APPLICATION, WarbleApplication);
	_tmp0_ = g_settings_new (CONSTANTS_APP_ID);
	_g_object_unref0 (warble_application_settings);
	warble_application_settings = _tmp0_;
	_tmp1_ = warble_models_dictionary_new ();
	_g_object_unref0 (warble_application_dictionary);
	warble_application_dictionary = _tmp1_;
	g_signal_connect_object ((GApplication*) self, "startup", (GCallback) __warble_application___lambda52__g_application_startup, self, 0);
	return obj;
}

static void
warble_application_class_init (WarbleApplicationClass * klass,
                               gpointer klass_data)
{
	struct utsname _tmp0_ = {0};
	const gchar* _tmp1_;
	warble_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WarbleApplication_private_offset);
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) warble_application_real_activate;
	G_OBJECT_CLASS (klass)->constructor = warble_application_constructor;
	G_OBJECT_CLASS (klass)->finalize = warble_application_finalize;
	g_info ("Application.vala:37: %s version: %s", CONSTANTS_APP_ID, CONSTANTS_VERSION);
	uname (&_tmp0_);
	_tmp1_ = _tmp0_.release;
	g_info ("Application.vala:38: Kernel version: %s", _tmp1_);
}

static void
warble_application_instance_init (WarbleApplication * self,
                                  gpointer klass)
{
	self->priv = warble_application_get_instance_private (self);
}

static void
warble_application_finalize (GObject * obj)
{
	WarbleApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_TYPE_APPLICATION, WarbleApplication);
	_g_object_unref0 (self->priv->main_window);
	G_OBJECT_CLASS (warble_application_parent_class)->finalize (obj);
}

static GType
warble_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarbleApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warble_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarbleApplication), 0, (GInstanceInitFunc) warble_application_instance_init, NULL };
	GType warble_application_type_id;
	warble_application_type_id = g_type_register_static (gtk_application_get_type (), "WarbleApplication", &g_define_type_info, 0);
	WarbleApplication_private_offset = g_type_add_instance_private (warble_application_type_id, sizeof (WarbleApplicationPrivate));
	return warble_application_type_id;
}

GType
warble_application_get_type (void)
{
	static volatile gsize warble_application_type_id__once = 0;
	if (g_once_init_enter (&warble_application_type_id__once)) {
		GType warble_application_type_id;
		warble_application_type_id = warble_application_get_type_once ();
		g_once_init_leave (&warble_application_type_id__once, warble_application_type_id);
	}
	return warble_application_type_id__once;
}

